Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QElasticCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QElasticCrossSection.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QElasticCrossSection.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QElasticCrossSection.cc,v 1.36 2008/03/21 21:42:44 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QElasticCrossSection.cc,v 1.37 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -34,4 +34,6 @@
 // 
 //================================================================================
+// Short description: Interaction cross-sections for the G4QElastic process
+// -------------------------------------------------------------------------------
 
 //#define debug
@@ -50,6 +52,6 @@
 G4double  G4QElasticCrossSection::lPMax= 8.;  // Max tabulated logarithmic Momentum     (D)
 G4double  G4QElasticCrossSection::dlnP=(lPMax-lPMin)/nLast;// Log step in the table     (D)
-G4bool    G4QElasticCrossSection::onlyCS=true;// Flag to calculate only CS (not Si/Bi)		(L)
-G4double  G4QElasticCrossSection::lastSIG=0.; // Last calculated cross section								  (L)
+G4bool    G4QElasticCrossSection::onlyCS=true;// Flag to calculate only CS (not Si/Bi)  (L)
+G4double  G4QElasticCrossSection::lastSIG=0.; // Last calculated cross section          (L)
 G4double  G4QElasticCrossSection::lastLP=-10.;// Last log(mom_of_the_incident_hadron)   (L)
 G4double  G4QElasticCrossSection::lastTM=0.;  // Last t_maximum                         (L)
@@ -63,17 +65,17 @@
 G4double  G4QElasticCrossSection::theS4=0.;   // The Last mantissa of 4-th difruction   (L)
 G4double  G4QElasticCrossSection::theB4=0.;   // The Last slope of 4-th difruction      (L)
-G4int     G4QElasticCrossSection::lastTZ=0;   // Last atomic number of the target				
+G4int     G4QElasticCrossSection::lastTZ=0;   // Last atomic number of the target    
 G4int     G4QElasticCrossSection::lastTN=0;   // Last number of neutrons of the target
 G4double  G4QElasticCrossSection::lastPIN=0.; // Last initialized max momentum
-G4double* G4QElasticCrossSection::lastCST=0;  // Elastic cross-section table															
-G4double* G4QElasticCrossSection::lastPAR=0;  // Parameters for functional calculation					
-G4double* G4QElasticCrossSection::lastSST=0;  // E-dep of sq.slope of the first difruction	
-G4double* G4QElasticCrossSection::lastS1T=0;  // E-dep of mantissa of the first difruction	
+G4double* G4QElasticCrossSection::lastCST=0;  // Elastic cross-section table               
+G4double* G4QElasticCrossSection::lastPAR=0;  // Parameters for functional calculation     
+G4double* G4QElasticCrossSection::lastSST=0;  // E-dep of sq.slope of the first difruction 
+G4double* G4QElasticCrossSection::lastS1T=0;  // E-dep of mantissa of the first difruction 
 G4double* G4QElasticCrossSection::lastB1T=0;  // E-dep of the slope of the first difruction
 G4double* G4QElasticCrossSection::lastS2T=0;  // E-dep of mantissa of the second difruction
 G4double* G4QElasticCrossSection::lastB2T=0;  // E-dep of the slope of theSecond difruction
-G4double* G4QElasticCrossSection::lastS3T=0;  // E-dep of mantissa of the third difruction	
+G4double* G4QElasticCrossSection::lastS3T=0;  // E-dep of mantissa of the third difruction 
 G4double* G4QElasticCrossSection::lastB3T=0;  // E-dep of the slope of the third difruction
-G4double* G4QElasticCrossSection::lastS4T=0;  // E-dep of mantissa of the 4-th difruction	
+G4double* G4QElasticCrossSection::lastS4T=0;  // E-dep of mantissa of the 4-th difruction 
 G4double* G4QElasticCrossSection::lastB4T=0;  // E-dep of the slope of the 4-th difruction
 G4int     G4QElasticCrossSection::lastPDG=0;  // The last PDG code of the projectile
@@ -159,5 +161,5 @@
   // ***---*** End of the mandatory Static Definitions of the Associative Memory ***---***
   if(tgZ==0 && tgN==1)                 // Temporary change for Quasi-Elastic
-		{
+  {
     tgZ=1;
     tgN=1;
@@ -171,5 +173,5 @@
         <<"("<<lastN<<"),PDG="<<pPDG<<"("<<lastPDG<<"), T="<<pEn<<"("<<lastTH<<")"<<",Sz="
         <<colN.size()<<G4endl;
-		//CalculateCrossSection(fCS,-27,j,lastPDG,lastZ,lastN,pMom); // DUMMY TEST
+  //CalculateCrossSection(fCS,-27,j,lastPDG,lastZ,lastN,pMom); // DUMMY TEST
 #endif
   if(!pPDG)
@@ -183,5 +185,5 @@
   G4bool in=false;                     // By default the isotope must be found in the AMDB
 //GF the block will update parameters, needed for quasi-eleastic
-//GF  if(tgN!=lastN || tgZ!=lastZ || pPDG!=lastPDG)// The nucleus was not the last used isotope
+//GF if(tgN!=lastN || tgZ!=lastZ || pPDG!=lastPDG)// The nucleus isn't the LastUsedIsotope
   {
     in = false;                        // By default the isotope haven't be found in AMDB  
@@ -192,7 +194,7 @@
     lastI   = colN.size();             // Size of the Associative Memory DB in the heap
     if(lastI) for(G4int i=0; i<lastI; i++) // Loop over proj/tgZ/tgN lines of DB
-	   {                                  // The nucleus with projPDG is found in AMDB
+    {                                  // The nucleus with projPDG is found in AMDB
       if(colPDG[i]==pPDG && colN[i]==tgN && colZ[i]==tgZ)
-						{
+      {
         lastI=i;
         lastTH =colTH[i];                // Last THreshold (A-dependent)
@@ -211,5 +213,5 @@
         lastP  =colP [i];                // Last Momentum  (A-dependent)
         lastCS =colCS[i];                // Last CrossSect (A-dependent)
-	//        if(std::fabs(lastP/pMom-1.)<tolerance) //VI (do not use tolerance)
+        //  if(std::fabs(lastP/pMom-1.)<tolerance) //VI (do not use tolerance)
         if(lastP == pMom)   // V.Ivanchenko safe solution
         {
@@ -244,7 +246,7 @@
       //CalculateCrossSection(fCS,-27,i,lastPDG,lastZ,lastN,pMom); // DUMMY TEST
 #endif
-	   }
-	   if(!in)                            // This nucleus has not been calculated previously
-	   {
+    }
+    if(!in)                            // This nucleus has not been calculated previously
+    {
 #ifdef pdebug
       G4cout<<"G4QElCS::GetCrosSec:CalcNew P="<<pMom<<",f="<<fCS<<",lastI="<<lastI<<G4endl;
@@ -253,5 +255,5 @@
       lastCS=CalculateCrossSection(fCS,0,lastI,lastPDG,lastZ,lastN,pMom);//calculate&create
       if(lastCS<=0.)
-						{
+      {
         lastTH = ThresholdEnergy(tgZ, tgN); // The Threshold Energy which is now the last
 #ifdef pdebug
@@ -265,5 +267,5 @@
           lastTH=pEn;
         }
-						}
+      }
 #ifdef pdebug
       G4cout<<"G4QElCS::GetCrosSec: New CS="<<lastCS<<",lZ="<<lastN<<",lN="<<lastZ<<G4endl;
@@ -281,7 +283,7 @@
 #endif
       return lastCS*millibarn;
-	   } // End of creation of the new set of parameters
+    } // End of creation of the new set of parameters
     else
-				{
+    {
 #ifdef pdebug
       G4cout<<"G4QElCS::GetCS: Update lastI="<<lastI<<G4endl;
@@ -293,32 +295,32 @@
   } // End of parameters udate
 
-// GF
-//	  else if(pEn<=lastTH)
-//	  {
-//	#ifdef pdebug
-//	    G4cout<<"G4QElCS::GetCS: Current T="<<pEn<<" < Threshold="<<lastTH<<", CS=0"<<G4endl;
-//	    //CalculateCrossSection(fCS,-27,lastI,lastPDG,lastZ,lastN,pMom); // DUMMY TEST
-//	#endif
-//	    return 0.;                         // Momentum is below the Threshold Value -> CS=0
-//	  }
-//	  //  else if(std::fabs(lastP/pMom-1.)<tolerance)
-//	  else if(lastP == pMom) // V.Ivanchenko safe solution
-//	  {
-//	#ifdef pdebug
-//	    G4cout<<"G4QElCS::GetCS:OldCur P="<<pMom<<"="<<pMom<<", CS="<<lastCS*millibarn<<G4endl;
-//	    //CalculateCrossSection(fCS,-27,lastI,lastPDG,lastZ,lastN,pMom); // DUMMY TEST
-//	    G4cout<<"G4QElCS::GetCrSec:***SAME***, onlyCS="<<onlyCS<<G4endl;
-//	#endif
-//	    return lastCS*millibarn;     // Use theLastCS
-//	  }
-//	  else
-//	  {
-//	#ifdef pdebug
-//	    G4cout<<"G4QElCS::GetCS:UpdatCur P="<<pMom<<",f="<<fCS<<",I="<<lastI<<",j="<<j<<G4endl;
-//	#endif
-//	    lastCS=CalculateCrossSection(fCS,1,lastI,lastPDG,lastZ,lastN,pMom); // Only UpdateDB
-//	    lastP=pMom;
-//	  }
-// GF
+//GF
+// else if(pEn<=lastTH)
+// {
+//#ifdef pdebug
+//  G4cout<<"G4QElCS::GetCS: Current T="<<pEn<<" < Threshold="<<lastTH<<", CS=0"<<G4endl;
+//  //CalculateCrossSection(fCS,-27,lastI,lastPDG,lastZ,lastN,pMom); // DUMMY TEST
+//#endif
+//  return 0.;                         // Momentum is below the Threshold Value -> CS=0
+// }
+// //  else if(std::fabs(lastP/pMom-1.)<tolerance)
+// else if(lastP == pMom) // V.Ivanchenko safe solution
+// {
+//#ifdef pdebug
+//  G4cout<<"G4QElCS::GetCS:OldCur P="<<pMom<<"="<<pMom<<", CS="<<lastCS*millibarn<<G4endl;
+//  //CalculateCrossSection(fCS,-27,lastI,lastPDG,lastZ,lastN,pMom); // DUMMY TEST
+//  G4cout<<"G4QElCS::GetCrSec:***SAME***, onlyCS="<<onlyCS<<G4endl;
+//#endif
+//  return lastCS*millibarn;     // Use theLastCS
+// }
+// else
+// {
+//#ifdef pdebug
+//  G4cout<<"G4QElCS::GetCS:UpdatCur P="<<pMom<<",f="<<fCS<<",I="<<lastI<<",j="<<j<<G4endl;
+//#endif
+//  lastCS=CalculateCrossSection(fCS,1,lastI,lastPDG,lastZ,lastN,pMom); // Only UpdateDB
+//  lastP=pMom;
+// }
+//GF
 
 #ifdef pdebug
@@ -339,5 +341,5 @@
   // *** End of Static Definitions (Associative Memory Data Base) ***
   if(tgZ==0 && tgN==1)                 // Temporary change for Quasi-Elastic
-		{
+  {
     tgZ=1;
     tgN=1;
@@ -352,5 +354,5 @@
   lastLP=std::log(pMom);                // Make a logarithm of the momentum for calculation
   if(F)                                 // This isotope was found in AMDB =>RETRIEVE/UPDATE
-		{
+  {
     if(F<0)                             // the AMDB must be loded
     {
@@ -378,22 +380,22 @@
       lastPIN=GetPTables(lastLP,lastPIN,PDG,tgZ,tgN);// Can update upper logP-Limit in tabs
 #ifdef pdebug
-						G4cout<<"G4QElCS::CalcCS:*updated(I)*,LP="<<lastLP<<"<IN["<<I<<"]="<<lastPIN<<G4endl;
+      G4cout<<"G4QElCS::CalcCS:*updated(I)*,LP="<<lastLP<<"<IN["<<I<<"]="<<lastPIN<<G4endl;
 #endif
       PIN[I]=lastPIN;                   // Remember the new P-Limit of the tables
     }
-	 }
-	 else                                  // This isotope wasn't initialized => CREATE
-	 {
+  }
+  else                                  // This isotope wasn't initialized => CREATE
+  {
     lastPAR = new G4double[nPoints];    // Allocate memory for parameters of CS function
     lastPAR[nLast]=0;                   // Initialization for VALGRIND
-    lastCST = new G4double[nPoints];    // Allocate memory for Tabulated CS function				
-    lastSST = new G4double[nPoints];    // Allocate memory for Tabulated first sqaredSlope	
-    lastS1T = new G4double[nPoints];    // Allocate memory for Tabulated first mantissa	
-    lastB1T = new G4double[nPoints];    // Allocate memory for Tabulated first slope				
+    lastCST = new G4double[nPoints];    // Allocate memory for Tabulated CS function    
+    lastSST = new G4double[nPoints];    // Allocate memory for Tabulated first sqaredSlope 
+    lastS1T = new G4double[nPoints];    // Allocate memory for Tabulated first mantissa 
+    lastB1T = new G4double[nPoints];    // Allocate memory for Tabulated first slope    
     lastS2T = new G4double[nPoints];    // Allocate memory for Tabulated second mantissa
-    lastB2T = new G4double[nPoints];    // Allocate memory for Tabulated second slope			
-    lastS3T = new G4double[nPoints];    // Allocate memory for Tabulated third mantissa	
+    lastB2T = new G4double[nPoints];    // Allocate memory for Tabulated second slope   
+    lastS3T = new G4double[nPoints];    // Allocate memory for Tabulated third mantissa 
     lastB3T = new G4double[nPoints];    // Allocate memory for Tabulated third slope    
-    lastS4T = new G4double[nPoints];    // Allocate memory for Tabulated 4-th mantissa	
+    lastS4T = new G4double[nPoints];    // Allocate memory for Tabulated 4-th mantissa 
     lastB4T = new G4double[nPoints];    // Allocate memory for Tabulated 4-th slope    
 #ifdef pdebug
@@ -406,15 +408,15 @@
     PIN.push_back(lastPIN);             // Fill parameters of CS function to AMDB
     PAR.push_back(lastPAR);             // Fill parameters of CS function to AMDB
-    CST.push_back(lastCST);             // Fill Tabulated CS function to AMDB				
-    SST.push_back(lastSST);             // Fill Tabulated first sq.slope to AMDB	
-    S1T.push_back(lastS1T);             // Fill Tabulated first mantissa to AMDB	
+    CST.push_back(lastCST);             // Fill Tabulated CS function to AMDB    
+    SST.push_back(lastSST);             // Fill Tabulated first sq.slope to AMDB 
+    S1T.push_back(lastS1T);             // Fill Tabulated first mantissa to AMDB 
     B1T.push_back(lastB1T);             // Fill Tabulated first slope to AMDB    
-    S2T.push_back(lastS2T);             // Fill Tabulated second mantissa to AMDB	
+    S2T.push_back(lastS2T);             // Fill Tabulated second mantissa to AMDB 
     B2T.push_back(lastB2T);             // Fill Tabulated second slope to AMDB    
-    S3T.push_back(lastS3T);             // Fill Tabulated third mantissa to AMDB	
+    S3T.push_back(lastS3T);             // Fill Tabulated third mantissa to AMDB 
     B3T.push_back(lastB3T);             // Fill Tabulated third slope to AMDB    
-    S4T.push_back(lastS4T);             // Fill Tabulated 4-th mantissa to AMDB	
+    S4T.push_back(lastS4T);             // Fill Tabulated 4-th mantissa to AMDB 
     B4T.push_back(lastB4T);             // Fill Tabulated 4-th slope to AMDB    
-	 } // End of creation/update of the new set of parameters and tables
+  } // End of creation/update of the new set of parameters and tables
   // ============= NOW Update (if necessary) and Calculate the Cross Section ===========
 #ifdef pdebug
@@ -459,5 +461,5 @@
       G4cout<<"G4QElasticCrossSection::CalculateCS:(E) S1="<<theS1<<", B1="<<theB1<<G4endl;
 #endif
-				}
+    }
     else
     {
@@ -540,5 +542,5 @@
   //                      -0- -1--2- -3-  -4-  -5-  -6-    -7-  -8- -9- -10--11--12--13-
   if(tgZ==0 && tgN==1)                 // Temporary change for Quasi-Elastic
-		{
+  {
     tgZ=1;
     tgN=1;
@@ -550,5 +552,5 @@
     // --- Total np elastic cross section cs & s1/b1 (t), s2/b2 (u) --- NotTuned for highE
     //p2=p*p;p3=p2*p;sp=sqrt(p);p2s=p2*sp;lp=log(p);dl1=lp-(5.=par(3));p4=p2*p2; p=|3-mom|
-				//CS=12./(p2s+.05*p+.0001/sqrt(sp))+.35/p+(6.75+.14*dl1*dl1+19./p)/(1.+.6/p4);
+    //CS=12./(p2s+.05*p+.0001/sqrt(sp))+.35/p+(6.75+.14*dl1*dl1+19./p)/(1.+.6/p4);
     //  par(0)   par(1) par(2)        par(4) par(5) par(6)     par(7)     par(8)
     //s1=(6.75+.14*dl2*dl2+13./p)/(1.+.14/p4)+.6/(p4+.00013), s2=(75.+.001/p4/p)/p3
@@ -559,5 +561,5 @@
     // -- Total pp elastic cross section cs & s1/b1 (main), s2/b2 (tail1), s3/b3 (tail2) --
     //p2=p*p;p3=p2*p;sp=sqrt(p);p2s=p2*sp;lp=log(p);dl1=lp-(3.=par(3));p4=p2*p2; p=|3-mom|
-				//CS=2.865/p2s/(1+.0022/p2s)+(18.9+.6461*dl1*dl1+9./p)/(1.+.425*lp)/(1.+.4276/p4);
+    //CS=2.865/p2s/(1+.0022/p2s)+(18.9+.6461*dl1*dl1+9./p)/(1.+.425*lp)/(1.+.4276/p4);
     //   par(0)       par(7)     par(1) par(2)      par(4)      par(5)         par(6)
     //dl2=lp-5., s1=(74.+3.*dl2*dl2)/(1+3.4/p4/p)+(.2/p2+17.*p)/(p4+.001*sp),
@@ -602,47 +604,46 @@
         G4double pa10=5.e-27*a10;
         // Reaction cross-section parameters (pel=peh_fit.f)
-        lastPAR[0]=.28*a;                                                        // p1
-        lastPAR[1]=4.8*std::pow(a,1.14)/(1.+3.6/a3);                             // p2(p/n)
-        lastPAR[2]=3.3/a+.5*ssa/(1.+2.e7/a8);                                    // p3
-        if(PDG==2112)
+        lastPAR[0]=a/3.;                                                       // p1(p/n)
+        //lastPAR[0]=.28*a;                                                      // p1(p/n)
+        lastPAR[1]=4.5*a*ssa/(1.+6./a3)/(1.+1.e-2*a);                          // p2(p/n)
+        //lastPAR[1]=4.8*std::pow(a,1.14)/(1.+3.6/a3);                           // p2(p/n)
+        if(PDG==2112)                           // Neutron projectile
         {
+          lastPAR[2]=3.3/a+.5*ssa/(1.+2.e7/a8);                                // p3 (old)
           if(a<6.5)
-								  {
-            lastPAR[3]=1./(1.+.00123*a4);                                        // p4
-            lastPAR[4]=1.5e-4/a2/(a+1.2e-6*a12)+1.5e-6;                          // p5
-            lastPAR[5]=.0062/(a+5.e-11*a16);                                     // p6
-            lastPAR[6]=3.2e-14/a6/(1.+4.e-10*a17);                               // p7
-            lastPAR[7]=.847/a4/(a+.0005*a8)+.00045;                              // p8
-            lastPAR[8]=.413/a16+7.e-7;                                           // p10
-								  }
+          {
+            lastPAR[3]=1./(1.+.00123*a4);                                      // p4
+            lastPAR[4]=1.5e-4/a2/(a+1.2e-6*a12)+1.5e-6;                        // p5
+            lastPAR[5]=.0062/(a+5.e-11*a16);                                   // p6
+            lastPAR[6]=3.2e-14/a6/(1.+4.e-10*a17);                             // p7
+            lastPAR[7]=.847/a4/(a+.0005*a8)+.00045;                            // p8
+            lastPAR[8]=.413/a16+7.e-7;                                         // p9
+          }
           else
           {
-            lastPAR[1]/=1.+4.e-3*a;      // @@ reduction for n, can be for p too // p2(n)
-            lastPAR[3]=a*(.5+1.e-10*a4)/(1.+7.e5/a6);                            // p4
-            lastPAR[4]=a*3.e-5/(1.+2.e12/a12);                                   // p5
-            lastPAR[5]=(.0006+1.e-14*a5)/(1.+4.e5/a3)/(1.+3.e23/a16/a8);         // p6
-            lastPAR[6]=1.e-22*a4/(1.+5.e16*(1.+5e31/a32)/a16);                   // p7
-            lastPAR[7]=(8.+.00016*a2)/(1.+1.4e14/a16);                           // p8
-            lastPAR[8]=.0013;                                                    // p10
+            lastPAR[3]=a*(.5+1.e-10*a4)/(1.+7.e5/a6);                          // p4
+            lastPAR[4]=a*3.e-5/(1.+2.e12/a12);                                 // p5
+            lastPAR[5]=(.0006+1.e-14*a5)/(1.+4.e5/a3)/(1.+3.e23/a16/a8);       // p6
+            lastPAR[6]=1.e-22*a4/(1.+5.e16*(1.+5e31/a32)/a16);                 // p7
+            lastPAR[7]=(8.+.00016*a2)/(1.+1.4e14/a16);                         // p8
+            lastPAR[8]=.0013;                                                  // p9
           }
-						  }
-        else
+        }
+        else                                   // Proton projectile
         {
-          lastPAR[2]=3.3/a+.7*ssa/(1.+2.e7/a8);                                  // p3
-          lastPAR[3]=1./(1.+6.e-9*a12)+.6*a/(1.+1.6e15/a16);                     // p4
-          lastPAR[4]=6.e-4/(a4+3.e-6*a12)+.16/(a+9.e5/a3+r1a16*r1a16);           // p5
-          lastPAR[5]=3.e-4/a2+(1.5e-3+3.e-14*a7)/(1.+r2a16*r2a16+3.e-12*a6);     // p6
-          lastPAR[6]=4.e-30+(1.2e-28*a3+pa10*pa10)/(1.+r3a16*r3a16+4.e-26*a14);  // p7
-          lastPAR[7]=.07/(1.+1.7e-8*a16)+.5/(1.+1.7e18/a16+4.5e-7*a4);           // p8
-          lastPAR[8]=(1.5e-10+2.e-18*a8)/(1.+3.e-25*a16);                        // p10
+          lastPAR[2]=3.3/a+.8*ssa/(1.+2.e7/a8);                                // p3
+          //lastPAR[2]=3.3/a+.7*ssa/(1.+2.e7/a8);                                // p3(old)
+          lastPAR[3]=1./(1.+6.e-9*a12)+.6*a/(1.+1.6e15/a16);                   // p4
+          lastPAR[4]=6.e-4/(a4+3.e-6*a12)+.16/(a+9.e5/a3+r1a16*r1a16);         // p5
+          lastPAR[5]=3.e-4/a2+(1.5e-3+3.e-14*a7)/(1.+r2a16*r2a16+3.e-12*a6);   // p6
+          lastPAR[6]=4.e-30+(1.2e-28*a3+pa10*pa10)/(1.+r3a16*r3a16+4.e-26*a14);// p7
+          lastPAR[7]=.1/(1.+1.7e-8*a16)+1./(1.+1.7e18/a16+2.e-6*a4);         // p8
+          //lastPAR[7]=.07/(1.+1.7e-8*a16)+.5/(1.+1.7e18/a16+4.5e-7*a4);         // p8(old)
+          lastPAR[8]=(1.5e-10+2.e-18*a8)/(1.+3.e-25*a16);                      // p9
         }
         // @@ the differential cross-section is parameterized separately for A>6 & A<7
         if(a<6.5)
-								{
-          // a11
-          // a13
+        {
           G4double a28=a16*a12;
-          // a31
-          // a40
           // The main pre-exponent      (pel_sg)
           lastPAR[ 9]=4000*a;                                // p1
@@ -664,7 +665,9 @@
           lastPAR[23]=3.5e-36*a32*a8/(1.+5.e-15*a32/a);      // p4
           // The 1st max pre-exponent   (pel_qq)
-          lastPAR[24]=8.e4/(a8+2.5e12/a16);                  // p1
-          lastPAR[25]=8.e7/(a12+1.e-27*a28*a28);             // p2
-          lastPAR[26]=.0011*a3;                              // p3
+          lastPAR[24]=1.e5/(a8+2.5e12/a16);                  // p1
+          //lastPAR[24]=8.e4/(a8+2.5e12/a16);                  // p1 (old)
+          lastPAR[25]=8.e7/(a12+1.e-27*a28*a28);             // p2 
+          lastPAR[26]=.0006*a3;                              // p3
+          //lastPAR[26]=.0011*a3;                              // p3 (old)
           // The 1st max slope          (pel_qs)
           lastPAR[27]=10.+4.e-8*a12*a;                       // p1
@@ -682,6 +685,8 @@
           lastPAR[37]=64./a3;                                // p4
           // The gloria pre-exponent    (pel_us)
-          lastPAR[38]=1.05e8*std::exp(.32*asa);              // p1
-          lastPAR[39]=19.5*std::exp(.45*asa);                // p2
+          lastPAR[38]=1.e8*std::exp(.32*asa);                // p1
+          //lastPAR[38]=1.05e8*std::exp(.32*asa);              // p1 (old)
+          lastPAR[39]=20.*std::exp(.45*asa);                // p2
+          //lastPAR[39]=19.5*std::exp(.45*asa);                // p2 (old)
           lastPAR[40]=7.e3+2.4e6/a5;                         // p3
           lastPAR[41]=2.5e5*std::exp(.085*a3);               // p4
@@ -696,5 +701,5 @@
         }
         else
-								{
+        {
           G4double p1a10=2.2e-28*a10;
           G4double r4a16=6.e14/a16;
@@ -779,10 +784,10 @@
 #ifdef pdebug
       G4cout<<"G4QElasticCrossSection::GetPTables:ip=0(init), lp="<<lp<<",S1="<<theS1
-												<<",B1="<<theB1<<",S2="<<theS2<<",B2="<<theB3<<",S3="<<theS3
+            <<",B1="<<theB1<<",S2="<<theS2<<",B2="<<theB3<<",S3="<<theS3
             <<",B3="<<theB3<<",S4="<<theS4<<",B4="<<theB4<<G4endl;
 #endif
     }
     if(LP>ILP)
-				{
+    {
       G4int ini = static_cast<int>((ILP-lPMin+.000001)/dlnP)+1; // already inited till this
       if(ini<0) ini=0;
@@ -795,5 +800,5 @@
           G4double lp=0.;
           for(G4int ip=ini; ip<=fin; ip++)        // Calculate tabular CS,S1,B1,S2,B2,S3,B3
-										{
+          {
             lp=lPMin+ip*dlnP;                     // ln(momentum)
             G4bool memCS=onlyCS;
@@ -848,5 +853,5 @@
   static const G4double sevth=1./7.;
   if(tgZ==0 && tgN==1)                 // Temporary change for Quasi-Elastic
-		{
+  {
     tgZ=1;
     tgN=1;
@@ -855,7 +860,7 @@
   }
 #ifdef tdebug
-  G4cout<<"G4QElasticCS::GetExchangeT:F="<<onlyCS<<",Z="<<tgZ<<",N="<<tgN<<",PDG="<<PDG<<G4endl;
-#endif
-  if(onlyCS) G4cout<<"*Warning*G4QElasticCrossSection::GetExchangeQ2: onlyCS=true"<<G4endl;
+  G4cout<<"G4QElasticCS::GetExcT:F="<<onlyCS<<",Z="<<tgZ<<",N="<<tgN<<",PDG="<<PDG<<G4endl;
+#endif
+  if(onlyCS) G4cout<<"**Warning*G4QElasticCrossSection::GetExchangeT: onlyCS=true"<<G4endl;
   if(lastLP<-4.3) return lastTM*GeVSQ*G4UniformRand();// S-wave for p<14 MeV/c (kinE<.1MeV)
   G4double q2=0.;
@@ -867,5 +872,5 @@
 #endif
     G4double E1=lastTM*theB1;
-  		G4double R1=(1.-std::exp(-E1));
+    G4double R1=(1.-std::exp(-E1));
 #ifdef tdebug
     G4double ts1=-std::log(1.-R1)/theB1;
@@ -876,5 +881,5 @@
 #endif
     G4double E2=lastTM*theB2;
-  		G4double R2=(1.-std::exp(-E2));
+    G4double R2=(1.-std::exp(-E2));
 #ifdef tdebug
     G4double ts2=-std::log(1.-R2)/theB2;
@@ -885,5 +890,5 @@
 #endif
     //G4double E3=lastTM*theB3;
-  		//G4double R3=(1.-std::exp(-E3));
+    //G4double R3=(1.-std::exp(-E3));
 #ifdef tdebug
     //G4double ts3=-std::log(1.-R3)/theB3;
@@ -891,7 +896,7 @@
     //if(ds3>.01)G4cout<<"*Warn*G4QElCS::GetExT:3n "<<ts3<<"#"<<lastTM<<",d="<<ds3<<G4endl;
 #endif
-  		G4double I1=R1*theS1;
-  		G4double I2=R2*theS2/theB2;
-				//G4double I3=R3*theS3/theB3;
+    G4double I1=R1*theS1;
+    G4double I2=R2*theS2/theB2;
+    //G4double I3=R3*theS3/theB3;
     G4double I12=I1+I2;
     //G4double rand=(I12+I3)*G4UniformRand();
@@ -903,5 +908,5 @@
       q2=-std::log(1.-ran)/theB1;       // t-chan
     }
-				else
+    else
     {
       G4double ran=R2*G4UniformRand();
@@ -917,5 +922,5 @@
 #endif
     G4double E1=lastTM*theB1;
-  		G4double R1=(1.-std::exp(-E1));
+    G4double R1=(1.-std::exp(-E1));
 #ifdef tdebug
     G4double ts1=-std::log(1.-R1)/theB1;
@@ -926,5 +931,5 @@
 #endif
     G4double E2=lastTM*theB2;
-  		G4double R2=(1.-std::exp(-E2*E2*E2));
+    G4double R2=(1.-std::exp(-E2*E2*E2));
 #ifdef tdebug
     G4double ts2=std::pow(-std::log(1.-R2),.333333333)/theB2;
@@ -935,5 +940,5 @@
 #endif
     G4double E3=lastTM*theB3;
-  		G4double R3=(1.-std::exp(-E3));
+    G4double R3=(1.-std::exp(-E3));
 #ifdef tdebug
     G4double ts3=-std::log(1.-R3)/theB3;
@@ -943,7 +948,7 @@
             <<",R3="<<R1<<",E3="<<E3<<G4endl;
 #endif
-  		G4double I1=R1*theS1/theB1;
-  		G4double I2=R2*theS2;
-				G4double I3=R3*theS3;
+    G4double I1=R1*theS1/theB1;
+    G4double I2=R2*theS2;
+    G4double I3=R3*theS3;
     G4double I12=I1+I2;
     G4double rand=(I12+I3)*G4UniformRand();
@@ -954,5 +959,5 @@
       q2=-std::log(1.-ran)/theB1;
     }
-				else if(rand<I12)
+    else if(rand<I12)
     {
       G4double ran=R2*G4UniformRand();
@@ -978,5 +983,5 @@
 #endif
     G4double E1=lastTM*(theB1+lastTM*theSS);
-  		G4double R1=(1.-std::exp(-E1));
+    G4double R1=(1.-std::exp(-E1));
     G4double tss=theSS+theSS; // for future solution of quadratic equation (imediate check)
 #ifdef tdebug
@@ -991,5 +996,5 @@
     G4double E2=lastTM*tm2*theB2;                   // power 3 for lowA, 5 for HighA (1st)
     if(a>6.5)E2*=tm2;                               // for heavy nuclei
-  		G4double R2=(1.-std::exp(-E2));
+    G4double R2=(1.-std::exp(-E2));
 #ifdef tdebug
     G4double ts2=-std::log(1.-R2)/theB2;
@@ -1003,5 +1008,5 @@
     G4double E3=lastTM*theB3;
     if(a>6.5)E3*=tm2*tm2*tm2;                       // power 1 for lowA, 7 (2nd) for HighA
-  		G4double R3=(1.-std::exp(-E3));
+    G4double R3=(1.-std::exp(-E3));
 #ifdef tdebug
     G4double ts3=-std::log(1.-R3)/theB3;
@@ -1013,5 +1018,5 @@
 #endif
     G4double E4=lastTM*theB4;
-  		G4double R4=(1.-std::exp(-E4));
+    G4double R4=(1.-std::exp(-E4));
 #ifdef tdebug
     G4double ts4=-std::log(1.-R4)/theB4;
@@ -1021,8 +1026,8 @@
             <<",R4="<<R4<<",E4="<<E4<<G4endl;
 #endif
-  		G4double I1=R1*theS1;
-  		G4double I2=R2*theS2;
-				G4double I3=R3*theS3;
-				G4double I4=R4*theS4;
+    G4double I1=R1*theS1;
+    G4double I2=R2*theS2;
+    G4double I3=R3*theS3;
+    G4double I4=R4*theS4;
     G4double I12=I1+I2;
     G4double I13=I12+I3;
@@ -1041,5 +1046,5 @@
 #endif
     }
-				else if(rand<I12)
+    else if(rand<I12)
     {
       G4double ran=R2*G4UniformRand();
@@ -1124,5 +1129,5 @@
 {
   if(tgZ==0 && tgN==1)                 // Temporary change for Quasi-Elastic
-		{
+  {
     tgZ=1;
     tgN=1;
@@ -1137,5 +1142,5 @@
   G4int iZ=tgZ-1; // Z index
   if(iZ<0)
-		{
+  {
     iZ=0;         // conversion of the neutron target to the proton target
     tgZ=1;
@@ -1162,5 +1167,5 @@
     G4double ssp=std::sqrt(sp);           // sqrt(sqrt(p))=p^.25
     G4double p2s=p2*sp;
-		  G4double dl1=lp-lastPAR[3];
+    G4double dl1=lp-lastPAR[3];
     theSS=lastPAR[21];
     theS1=(lastPAR[9]+lastPAR[10]*dl1*dl1+lastPAR[11]/p)/(1.+lastPAR[12]/p4)
@@ -1185,6 +1190,6 @@
 
     G4double p2s=p2*sp;
-		  G4double dl1=lp-lastPAR[3];
-		  G4double dl2=lp-lastPAR[8];
+    G4double dl1=lp-lastPAR[3];
+    G4double dl2=lp-lastPAR[8];
     theSS=lastPAR[31];
     theS1=(lastPAR[9]+lastPAR[10]*dl2*dl2)/(1.+lastPAR[11]/p4/p)+
@@ -1214,5 +1219,5 @@
     G4double p16=p8*p8;
     //G4double p24=p16*p8;
-		  G4double dl=lp-5.;
+    G4double dl=lp-5.;
     G4double a=tgZ+tgN;
     G4double pah=std::pow(p,a/2);
@@ -1226,10 +1231,10 @@
       theSS=lastPAR[20]/(1.+lastPAR[21]/p2)+lastPAR[22]/(p6/pa+lastPAR[23]/p16);
       theS2=lastPAR[24]/(pa/p2+lastPAR[25]/p4)+lastPAR[26];
-				  theB2=lastPAR[27]*std::pow(p,lastPAR[28])+lastPAR[29]/(p8+lastPAR[30]/p16);
-				  theS3=lastPAR[31]/(pa*p+lastPAR[32]/pa)+lastPAR[33];
-				  theB3=lastPAR[34]/(p3+lastPAR[35]/p6)+lastPAR[36]/(1.+lastPAR[37]/p2);
-				  theS4=p2*(pah*lastPAR[38]*std::exp(-pah*lastPAR[39])+
+      theB2=lastPAR[27]*std::pow(p,lastPAR[28])+lastPAR[29]/(p8+lastPAR[30]/p16);
+      theS3=lastPAR[31]/(pa*p+lastPAR[32]/pa)+lastPAR[33];
+      theB3=lastPAR[34]/(p3+lastPAR[35]/p6)+lastPAR[36]/(1.+lastPAR[37]/p2);
+      theS4=p2*(pah*lastPAR[38]*std::exp(-pah*lastPAR[39])+
                 lastPAR[40]/(1.+lastPAR[41]*std::pow(p,lastPAR[42])));
-				  theB4=lastPAR[43]*pa/p2/(1.+pa*lastPAR[44]);
+      theB4=lastPAR[43]*pa/p2/(1.+pa*lastPAR[44]);
 #ifdef tdebug
       G4cout<<"G4QElCS::GetTabV: lA, p="<<p<<",S1="<<theS1<<",B1="<<theB1<<",SS="<<theSS
@@ -1246,11 +1251,11 @@
       theSS=lastPAR[21]/(p4/std::pow(p,lastPAR[23])+lastPAR[22]/p4);
       theS2=lastPAR[24]/p4/(std::pow(p,lastPAR[25])+lastPAR[26]/p12)+lastPAR[27];
-				  theB2=lastPAR[28]/std::pow(p,lastPAR[29])+lastPAR[30]/std::pow(p,lastPAR[31]);
-				  theS3=lastPAR[32]/std::pow(p,lastPAR[35])/(1.+lastPAR[36]/p12)+
+      theB2=lastPAR[28]/std::pow(p,lastPAR[29])+lastPAR[30]/std::pow(p,lastPAR[31]);
+      theS3=lastPAR[32]/std::pow(p,lastPAR[35])/(1.+lastPAR[36]/p12)+
             lastPAR[33]/(1.+lastPAR[34]/p6);
-				  theB3=lastPAR[37]/p8+lastPAR[38]/p2+lastPAR[39]/(1.+lastPAR[40]/p8);
-				  theS4=(lastPAR[41]/p4+lastPAR[46]/p)/(1.+lastPAR[42]/p10)+
+      theB3=lastPAR[37]/p8+lastPAR[38]/p2+lastPAR[39]/(1.+lastPAR[40]/p8);
+      theS4=(lastPAR[41]/p4+lastPAR[46]/p)/(1.+lastPAR[42]/p10)+
             (lastPAR[43]+lastPAR[44]*dl*dl)/(1.+lastPAR[45]/p12);
-				  theB4=lastPAR[47]/(1.+lastPAR[48]/p)+lastPAR[49]*p4/(1.+lastPAR[50]*p5);
+      theB4=lastPAR[47]/(1.+lastPAR[48]/p)+lastPAR[49]*p4/(1.+lastPAR[50]*p5);
 #ifdef tdebug
       G4cout<<"G4QElCS::GetTabV: hA, p="<<p<<",S1="<<theS1<<",B1="<<theB1<<",SS="<<theSS
@@ -1276,5 +1281,5 @@
      return (lastPAR[0]*dl*dl+lastPAR[1])/(1.+lastPAR[2]/p)+lastPAR[3]/(p4+lastPAR[4]/p2)+
             lastPAR[5]/(p8+lastPAR[6]/p8)+lastPAR[7]/(p2+lastPAR[8]);
-				//else
+    //else
     //{
     //  G4int nI=nn[iZ];
@@ -1286,6 +1291,6 @@
 #endif
     //    if(kE<nT[iZ][i]) return 0.;    // 0 below the threshold (in MeV)
-				//   if(p<2.) return nX[iZ][i];     // At very low momentum(<2MeV/c) -> only LECS
-    //				return lastPAR[3]/(p4+lastPAR[4]/p2)+lastPAR[5]/(p5+rp16*rp16)+
+    //   if(p<2.) return nX[iZ][i];     // At very low momentum(<2MeV/c) -> only LECS
+    //    return lastPAR[3]/(p4+lastPAR[4]/p2)+lastPAR[5]/(p5+rp16*rp16)+
     //           lastPAR[7]/(p4+lastPAR[8]/p4)+nX[iZ][i]/(1.+lastPAR[51]*p16);
     //  }
@@ -1315,5 +1320,5 @@
   //static const G4double mDeut2= mDeut*mDeut;
   if(tgZ==0 && tgN==1)                 // Temporary change for Quasi-Elastic
-		{
+  {
     tgZ=1;
     tgN=1;
